/*
 * log.c
 *
 *  Created on: Nov 7, 2022
 *      Author: tangm
 */
#include "log.h"
#include <stdarg.h>
#include <stdio.h>
#include "usart.h"
///ضc⺯printfڣضʹprintf
int fputc(int ch, FILE *f)
{
		/* һֽݵ */
		USART_SendData(USART_232, (uint8_t) ch);
		
		/* ȴ */
		while (USART_GetFlagStatus(USART_232, USART_FLAG_TXE) == RESET);	
		return (ch);
}

///ضc⺯scanfڣдʹscanfgetcharȺ
int fgetc(FILE *f)
{
		/* ȴ */
		while (USART_GetFlagStatus(USART_232, USART_FLAG_RXNE) == RESET);

		return (int)USART_ReceiveData(USART_232);
}

void LogPrint(logLevel_t logLevel, const char *func, const int line, char * fmt, ...)
{
	va_list args;
	va_start(args, fmt);
	char buf[LOG_LEN_MAX];
	vsnprintf(buf, sizeof(buf), fmt, args);
	va_end(args);
	switch (logLevel)
	{
#ifdef _LOG_INFO
		case LOG_INFO:
			printf("LOG[%-5s][%-20s:%4d] %s\r\n", "INFO", func, line, buf);
			break;
#endif
#ifdef _LOG_DEBUG
		case LOG_DEBUG:
			printf("LOG[%-5s][%-20s:%4d] %s\r\n", "DEBUG", func, line, buf);
			break;
#endif
#ifdef _LOG_WARN
		case LOG_WARN:
			printf("LOG[%-5s][%-20s:%4d] %s\r\n", "WARN", func, line, buf);
			break;
#endif
		case LOG_ERROR:
			printf("LOG[%-5s][%-20s:%4d] %s\r\n", "ERROR", func, line, buf);
			break;
		default:
			break;
	}
}
